services:
    netbox:
        image: code.europa.eu:4567/digit-c4/netbox-plugins:${TAG}
        container_name: netbox
        ports:
            - 8000:8080
        depends_on:
            postgres:
                condition: service_healthy
            redis:
                condition: service_started
            redis-cache:
                condition: service_started
        user: 'unit:root'
        healthcheck:
            interval: 60s
            start_period: 60s
            start_interval: 5s
            retries: 5
            test: "curl -f http://localhost:8080/api/ || exit 1"
        env_file: env/netbox.env
        volumes:
            - netbox-media-files:/opt/netbox/netbox/media
            - netbox-reports-files:/opt/netbox/netbox/reports
            - netbox-scripts-files:/opt/netbox/netbox/scripts
        environment:
            - ACTIVATE_WORKER_AND_HOUSEKEEPING=1
        networks:
            - c4-gateway-galaxy
    postgres:
        image: docker.io/postgres:15-alpine
        env_file: env/postgres.env
        healthcheck:
            interval: 60s
            start_period: 60s
            start_interval: 10s
            retries: 5
            test: "pg_isready -h localhost -U $$POSTGRES_USER"
        volumes:
            - netbox-postgres-data:/var/lib/postgresql/data
            - ./docker/postgres/docker-entrypoint-initdb.d:/docker-entrypoint-initdb.d
        networks:
            - c4-gateway-galaxy
    redis:
        image: docker.io/redis:7-alpine
        env_file: env/redis.env
        command:
            - sh
            - -c # this is to evaluate the $REDIS_PASSWORD from the env
            - redis-server --appendonly yes --requirepass $$REDIS_PASSWORD ## $$ because of docker-compose
        volumes:
            - netbox-redis-data:/data
        networks:
            - c4-gateway-galaxy
    redis-cache:
        image: docker.io/redis:7-alpine
        env_file: env/redis-cache.env
        command:
            - sh
            - -c # this is to evaluate the $REDIS_PASSWORD from the env
            - redis-server --requirepass $$REDIS_PASSWORD ## $$ because of docker-compose
        volumes:
            - netbox-redis-cache-data:/data
        networks:
            - c4-gateway-galaxy
    c4-gtw-gxy:
        build:
            context: .
        container_name: c4-gtw-gxy
        # volumes:
        #    - .:/data
        ports:
            - 1882:1880
        environment:
            - ENABLE_EDITOR=true
            - NETBOX_BASE_URL=http://netbox:8080
            - NETBOX_API_TOKEN=this1tokenshouldbeusedfortestingpurposes
        networks:
            - c4-gateway-galaxy
volumes:
    netbox-media-files:
        driver: local
    netbox-postgres-data:
        driver: local
    netbox-redis-cache-data:
        driver: local
    netbox-redis-data:
        driver: local
    netbox-reports-files:
        driver: local
    netbox-scripts-files:
        driver: local
    netbox-docker-agent:
        driver: local
networks:
    c4-gateway-galaxy:
